--[[
	NumberPlatesFix.lua
	
	Autor: Ifko[nator]
	Datum: 06.09.2017

	This script will delete the old number plate to allow toggle a new one
]]
	
for index = 1, 20 do --## go through all 20 possible savgames ..
	savegameFolderPath = string.format("%ssavegame%d", getUserProfileAppPath(), index);

	if fileExists(savegameFolderPath .. "/vehicles.xml") then
		--print("found vehicles.xml: " .. savegameFolderPath .. "/vehicles.xml :)");
		local vehicles = loadXMLFile("vehicles", savegameFolderPath .. "/vehicles.xml", "careerVehicles");
		
		local i = 0;
	
		while true do
			local saveGameVehicle = string.format("careerVehicles.vehicle(%d)", i);
			
			if not hasXMLProperty(vehicles, saveGameVehicle) then
				break;
			end;
			
			--local id = getXMLInt(vehicles, saveGameVehicle .. "#id");
			local filename = getXMLString(vehicles, saveGameVehicle .. "#filename");
			
			--[[print("----------------------------------- vehicle " .. i .. " -----------------------------------");
			print("id is " .. id);
			print("filename is " .. tostring(filename));
			print("g_currentModName is " .. tostring(g_currentModName));]]
			
			if string.find(filename, g_currentModName) then
				local plateSigns = getXMLString(vehicles,  saveGameVehicle .. "#plateSigns");
				local hasLoadedNewPlateSigns = Utils.getNoNil(getXMLBool(vehicles,  saveGameVehicle .. "#hasLoadedNewPlateSigns"), false);
				
				if plateSigns ~= nil and not hasLoadedNewPlateSigns then
					setXMLString(vehicles,  saveGameVehicle .. "#plateSigns", "1");
					
					--print("change plateSigns in " .. g_currentModName);
					
					saveXMLFile(vehicles);
				end;
			end;
			
			--print("");
			
			i = i + 1;
		end;
	end;
end;

local currentModName = g_currentModName;

local function saveSavegame() --## save the 'hasLoadedNewPlateSigns' for the vehicle, wich has this lua
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	
	if savegameFolderPath == nil then
		local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	
		savegameFolderPath = string.format("%ssavegame%d", getUserProfileAppPath(), savegameIndex);
	end;

	if fileExists(savegameFolderPath .. "/vehicles.xml") then
		local vehicles = loadXMLFile("vehicles", savegameFolderPath .. "/vehicles.xml", "careerVehicles");
		
		local i = 0;
	
		while true do
			local saveGameVehicle = string.format("careerVehicles.vehicle(%d)", i);
			
			if not hasXMLProperty(vehicles, saveGameVehicle) then
				break;
			end;
			
			local id = getXMLInt(vehicles, saveGameVehicle .. "#id");
			local filename = getXMLString(vehicles, saveGameVehicle .. "#filename");
			
			if string.find(filename, currentModName) then
				setXMLBool(vehicles, saveGameVehicle .. "#hasLoadedNewPlateSigns", true);
				
				saveXMLFile(vehicles);
			end;
			
			i = i + 1;
		end;
	end;
end;

g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, saveSavegame);